;;;; lisp-libvirt.lisp

(in-package #:lisp-libvirt)

;;; "lisp-libvirt" goes here. Hacks and glory await!

(define-foreign-library libvirt
  (:unix (:or "libvirt.so.0" "libvirt.so.0.1002.18"))
  (t (:default "libvirt")))

(use-foreign-library libvirt)

(defcenum virtual-connect-close-reason
  (:error 0)
  (:eof 1)
  (:keepalive 2)
  (:client 3)
  (:last 4))

(defcunion virtual-typed-parameter-union
  (int :int)
  (unsigned-int :unsigned-int)
  (long-long-int :long-long)
  (unsigned-long-long-int :unsigned-long-long)
  (double :double)
  (boolean :char)
  (string :string))

(defcstruct virtual-typed-parameter
  (field :string)
  (type :int)
  (value virtual-typed-parameter-union))

(defcenum virtual-typed-parameter-flags
  (:okay 4))

(defcenum virtual-typed-parameter-type
  (:int 1)
  (:uint 2)
  (:llong 3)
  (:ullong 4)
  (:double 5)
  (:boolean 6)
  (:string 7)
  (:last 8))
